//+------------------------------------------------------------------+
//|                                                  Free Candle.mq4 |
//|                                                            Urain |
/*///+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
        .
       . 
     .
/*///+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
#property copyright "Urain"
#property link      "http://www.mql4.com/ru/users/Urain"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 DodgerBlue

extern int _Ema=9;
extern int TP=30;
extern bool Spred=1;
extern int UTC=2;
//---- buffers
double b[];
double s[];
double r[];
double iPoint;
int sum=0;
//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+

int init()
{//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
   IndicatorBuffers(3); 
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,217);
   SetIndexBuffer(0,b);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,218);
   SetIndexBuffer(1,s);
   SetIndexEmptyValue(1,0.0);
   SetIndexBuffer(2,r);
   iPoint=1.0/Point;
return(0);
}//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+

int deinit()
{//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
 Comment("");
 ObjectsDeleteAll(0,OBJ_TREND);
return(0);
}//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+

int start()
{//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
 for(int i=Bars-_Ema-2-IndicatorCounted();i>0;i--)
    {double Ema9=nd(iMA(NULL,0,_Ema,0,MODE_EMA ,PRICE_CLOSE,i));
     if(Low[i]>Ema9 && Close[i]>High[i+1] && Close[i]>Open[i]){s[i-1]=0;b[i-1]=Open[i-1];}
     else 
       {if(High[i]<Ema9 && Close[i]<Low[i+1] && Close[i]<Open[i]){b[i-1]=0;s[i-1]=Open[i-1];}
        else 
          {b[i-1]=0;s[i-1]=0;
          }
       }
    }
 bool f=1; 
 double bn=0,bk=0,sn=0,sk=0,tp=0,sl=0; 
 datetime tn=0,tk=0;  
 for(i=Bars-_Ema-5-IndicatorCounted();i>=0;i--)
    {if((High[i]>=tp||Low[i]<=sl) &&bn!=0&&!f)
       {tk=Time[i];
        if(High[i]>=tp){bk=tp;}
        else{bk=sl;}
        sum+=(bk-bn-spred.())*iPoint;
        _("buy_"+tn,Red,tn,bn,tk,bk,0);
        bn=0;
        f=1; 
       }
     if((Low[i]<=tp||High[i]>=sl) &&sn!=0&&!f)
       {tk=Time[i]; 
        if(Low[i]<=tp){sk=tp;}
        else{sk=sl;}
        sum+=(sn-sk-spred.())*iPoint;
        _("sell_"+tn,DodgerBlue,tn,sn,tk,sk,0);
        sn=0;
        f=1;
       }
     if(b[i]!=0&&f&&sessija(i))
       {sl=Low[i+2];  
        tp=b[i]+TP*Point; 
        bn=b[i]; 
        tn=Time[i]; 
        f=0;
       }
     if(s[i]!=0&&f&&sessija(i))
       {sl=High[i+2]; 
        tp=s[i]-TP*Point; 
        sn=s[i]; 
        tn=Time[i]; 
        f=0;
       } 
    }
 if(Spred)Comment("       [",sum,"]");
 else Comment("       [",sum,"]");      
return(0);
}//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
//    void int double bool datetime string color extern  
double  spred.(){return(MarketInfo(Symbol(),MODE_SPREAD)*Point*Spred);}
double nd(double v){return(NormalizeDouble(v,Digits));}

void _(string name,color ,datetime t1,double p1,datetime t2,double p2,int RAY)
{//+------------------------------------------------------------------+
 if(ObjectFind(name)==-1)ObjectCreate(name,OBJ_TREND,0,0,0,0,0);
 ObjectSet(name,OBJPROP_TIME1,t1);
 ObjectSet(name,OBJPROP_TIME2,t2);
 ObjectSet(name,OBJPROP_PRICE1,p1);
 ObjectSet(name,OBJPROP_PRICE2,p2);  
 ObjectSet(name,OBJPROP_RAY,RAY);
 ObjectSet(name,OBJPROP_COLOR,);  
return;
}//+------------------------------------------------------------------+

bool sessija(int i)
{//+------------------------------------------------------------------+
 if(7+UTC<=TimeHour(Time[i])&&9+UTC>TimeHour(Time[i]))return(true);
 if(13+UTC<=TimeHour(Time[i])&&15+UTC>TimeHour(Time[i]))return(true);
 return(false);
}//+------------------------------------------------------------------+

